      PROGRAM POLYLAD
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PROGRAM MODIFIED 2/24/2007
C
      CHARACTER  FIN*40,FOUT*40
C
      WRITE(*,1000) '*** PROGRAM POLYLAD ***'
 1000 FORMAT(T19,A)
      WRITE(*,1100) 'PROGRAM POLYLAD COMPUTES A LEAST ABSOLUTE ',
     +              'DEVIATION REGRESSION MODEL','AND RHO OF AN ',
     +              'EXISTING DATA SET, USING THE ACM ALGORITHM ',
     +              'NUMBER 478.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 1500 INDEPENDENT AND DEPENDENT OBSERVATIONS,',
     +              'N = 15 FOR AN NTH ORDER POLYNOMIAL FIT.',
     +              'RESULTS OF THIS PROGRAM ARE IN NAMED OUTPUT FILE.'
 1100 FORMAT(1(/),T2,A,A,/,T6,A,A,A,/,T2,A,/,T10,A,/,T10,A,/,T2,A)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INDEPENDENT AND DEPENDENT DATA:'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER ORDER OF POLYNOMIAL, 0 < N < 16:'
      READ(*,*) N
      IF(N.LT.1.OR.N.GT.15) STOP '0 < N < 16 IS NOT SATISFIED.'
      WRITE(*,*) 'ENTER POWER OF FIRST ORDER INDEPENDENT VALUE:'
      READ(*,*) POWER
      TOLER = 1.0D-9
      WRITE(*,1300) 'TOLERANCE = ', TOLER
 1300 FORMAT(T10,A,E10.4)
      N = N+1
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      CALL LEAST(TOLER,N,POWER)
      STOP 'POLYLAD RESULTS IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE LEAST(TOLER,N,POWER)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(1502,18),X(16),E(1500),B(1500),Y(1500),YH(1500),
     +           LS(1500)
C
      READ(4,*) M
      READ(4,*) (A(I,2),A(I,N+1),I = 1,M)
      CLOSE(4)
      ONE = 1.0D0
      ZERO = 0.0D0
      DO 100 I = 1,M
         A(I,1) = ONE
         A(I,2) = A(I,2)**POWER
  100 CONTINUE
      IF(N.EQ.1) GO TO 500
      DO 300 I = 1,M
         DO 200 J = 3,N
            A(I,J) = A(I,J-1)*A(I,2)
  200    CONTINUE
  300 CONTINUE
  500 DO 1000 I = 1,M
         B(I) = A(I,N+1)
         Y(I) = B(I)
 1000 CONTINUE
      WRITE(7,1100)
 1100 FORMAT(T25,'*** OUTPUT OF POLYLAD ANALYSIS ***',2(/))
      WRITE(7,1200) N-1
 1200 FORMAT(T5,'ORDER OF POLYNOMIAL FIT = ',I2)
      WRITE(7,1400) POWER
 1400 FORMAT(T5,'POWER OF FIRST ORDER INDEPENDENT VALUE = ',G15.8,/)
      M2 = M+2
      N2 = N+2
C
      CALL L1(M,N,M2,N2,A,B,TOLER,X,E,LS)
C
      DO 1700 I = 1,N
         WRITE(7,1600) 'LAD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      IRANK = A(M+1,N+2)
      ITER = A(M+2,N+2)
      IEXCODE = A(M+2,N+1)
      SUMRE = A(M+1,N+1)
      DELTA = SUMRE/M
      WRITE(7,1800) IRANK,ITER,IEXCODE
 1800 FORMAT(/,T5,'MATRIX RANK = ',I3,/,T5,'ITERATIONS =  ',I3,/,T5,
     +   'EXIT CODE =   ',I3)
      WRITE(7,1900) 'NOTE: EXIT CODE 0 INDICATES A NON-UNIQUE ',
     +   'SOLUTION.','NOTE: EXIT CODE 1 INDICATES A SUCCESSFUL ',
     +   'SOLUTION.','NOTE: EXIT CODE 2 INDICATES ROUNDING ERRORS.'
 1900 FORMAT(/,T5,A,A,/,T5,A,A,/,T5,A)
      WRITE(7,2000) M
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I4,/)
      DO 2100 I = 1,M
         YH(I) = Y(I)-E(I)
 2100 CONTINUE
      CALL MRBP(M,Y,YH,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      CALL DIST(M,Y,PY)
      CALL DIST(M,E,PE)
      WRITE(7,2200) 'OBSERVED VALUE OF DELTA = ',DELTA
 2200 FORMAT(T5,A,G15.8E3)
      WRITE(7,2200) 'EXPECTED VALUE OF DELTA = ',EDEL
      WRITE(7,2200) 'VARIANCE OF DELTA = ',VAR
      WRITE(7,2200) 'SKEWNESS OF DELTA = ',GAM
      WRITE(7,2200) 'STANDARDIZED VALUE OF DELTA = ',T
      WRITE(7,2200) 'MEASURE OF AGREEMENT BETWEEN Y AND Y-HAT = ',RHO
      WRITE(7,2200) 'P-VALUE FOR THIS LAD REGRESSION FUNCTION = ',PROB
      WRITE(7,2200) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF Y = ',PY
      WRITE(7,2300) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF E = ',PE
 2300 FORMAT(T5,A,G15.8E3,/)
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DO 2400 I = 1,M
          CO = CO+Y(I)
          COO = COO+Y(I)**2
          CP = CP+YH(I)
          CPP = CPP+YH(I)**2
          COP = COP+Y(I)*YH(I)
 2400 CONTINUE
      R = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR =  R*R
      WRITE(7,2200) 'PEARSON CORRELATION COEFFICIENT = ',R
      WRITE(7,2300) 'SQUARED CORRELATION COEFFICIENT = ',RR
      WRITE(7,2500)
 2500 FORMAT(/,T26,'*** END OF POLYLAD ANALYSIS ***')
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,M2,N2,A,B,TOLER,X,E,LS)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(1502,18),X(16),E(1500),B(1500),LS(1500)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE MRBP(KG,Y,YH,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  DATA(1500,2),Y(1500),YH(1500)
C
      V = 1.0D0
      DO 20 I = 1,KG
         DATA(I,1) = Y(I)
         DATA(I,2) = YH(I)
   20 CONTINUE
      CALL CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      RETURN
      END
C
C
      SUBROUTINE CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  D(3000,3000),SJ(1500,2,2),SJ2(1500,2,2),SJ3(1500,2,2),
     1   UJ(500,2,2),DATA(1500,2),SIJ(2,2),SIJ2(2,2),SIJ3(2,2),
     2   UIJ(2,2),TIJ2(2,2),TIJ3(2,2),VI(2,2)
C
      ONE=1.0D0
      ZERO=0.0D0
      K2G=KG*2
      DO 4 I=1,K2G
         DO 3 J=1,K2G
            D(I,J)=ZERO
    3    CONTINUE
    4 CONTINUE
      DO 10 I=1,KG
         DO 9 J=1,2
            DO 8 K=I,KG
               LO=1
               IF(I.EQ.K) LO=J
               DO 7 L=LO,2
                  IJ=2*(I-1)+J
                  KL=2*(K-1)+L
                  D(IJ,KL)=D(IJ,KL)+(DATA(I,J)-DATA(K,L))**2
                  D(IJ,KL)=D(IJ,KL)**(V/2)
                  D(KL,IJ)=D(IJ,KL)
    7          CONTINUE
    8       CONTINUE
    9    CONTINUE
   10 CONTINUE
      DO 30 IS=1,2
         DO 29 IR=1,2
            IF(IR.EQ.IS) GO TO 29
            SIJ(IR,IS)=ZERO
            SIJ2(IR,IS)=ZERO
            SIJ3(IR,IS)=ZERO
            DO 28 I=1,KG
               SJ(I,IR,IS)=ZERO
               SJ2(I,IR,IS)=ZERO
               SJ3(I,IR,IS)=ZERO
               DO 27 J=1,KG
                  IRR=(I-1)*2+IR
                  JSS=(J-1)*2+IS
                  SJ(I,IR,IS)=SJ(I,IR,IS)+D(IRR,JSS)
                  SJ2(I,IR,IS)=SJ2(I,IR,IS)+D(IRR,JSS)**2
                  SJ3(I,IR,IS)=SJ3(I,IR,IS)+D(IRR,JSS)**3
   27          CONTINUE
               SIJ(IR,IS)=SIJ(IR,IS)+SJ(I,IR,IS)
               SIJ2(IR,IS)=SIJ2(IR,IS)+SJ2(I,IR,IS)
               SIJ3(IR,IS)=SIJ3(IR,IS)+SJ3(I,IR,IS)
   28       CONTINUE
   29    CONTINUE
   30 CONTINUE
      TIJ2(1,2)=ZERO
      TIJ3(1,2)=ZERO
      VI(1,2)=ZERO
      UIJ(1,2)=ZERO
      DO 100 I=1,KG
         TIJ2(1,2)=TIJ2(1,2)+SJ(I,1,2)**2+
     1     SJ(I,2,1)**2
         TIJ3(1,2)=TIJ3(1,2)+SJ(I,1,2)**3+
     1     SJ(I,2,1)**3
         VI(1,2)=VI(1,2)+SJ(I,1,2)*SJ2(I,1,2)+
     1     SJ(I,2,1)*SJ2(I,2,1)
         UJ(I,1,2)=ZERO
         DO 90 J=1,KG
            IRR=2*(I-1)+1
            JSS=2*(J-1)+2
            UJ(I,1,2)=UJ(I,1,2)+
     1        D(IRR,JSS)*SJ(I,1,2)*SJ(J,2,1)
   90    CONTINUE
         UIJ(1,2)=UIJ(1,2)+UJ(I,1,2)
  100 CONTINUE
      T1=ZERO
      EDEL=ZERO
      VAR=ZERO
      IF(KG.LE.2) GO TO 150
      T1=T1+(SIJ(1,2)**3)*4-SIJ(1,2)*TIJ2(1,2)*KG*6+
     1  UIJ(1,2)*KG*KG*6+TIJ3(1,2)*KG*KG*2+
     2  SIJ(1,2)*SIJ2(1,2)*KG*KG*3-
     3  VI(1,2)*KG*KG*KG*3+SIJ3(1,2)*KG*KG*KG*KG
  150 EDEL=EDEL+SIJ(1,2)
      VAR=VAR+SIJ(1,2)*SIJ(1,2)-TIJ2(1,2)*KG+SIJ2(1,2)*KG*KG
      IF(KG.LE.2) GO TO 200
      T1=T1/(KG-2)
  200 C1=ONE/KG/KG
      EDEL=C1*EDEL
      VAR=VAR*C1*C1/(KG-1)
      GAM=C1*C1*C1*T1/(KG-1)
      GAM=GAM/DSQRT(VAR**3)
      T=(DELTA-EDEL)/DSQRT(VAR)
      RHO=ONE-(DELTA/EDEL)
      CALL PVALUE(T,GAM,PROB)
      RETURN
      END
C
C
      SUBROUTINE DIST(NCASES,DATA,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE DIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  B(12),DATA(1500),DC(3,1500),DEL(1500,1500),Q(6)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DBAR = ZERO
      DO 1400 I = 1,NCASES
         DO 1300 J = 1,NCASES
            DEL(I,J) = DABS(DATA(I)-DATA(J))
 1300    CONTINUE
 1400 CONTINUE
      DO 1600 I = 1,NCASES-1
         DBAR = DBAR+DEL(I,I+1)
 1600 CONTINUE
      DBAR = DBAR/(NCASES-1)
      DO 2150 I = 1,NCASES
         DO 2140 K = 1,3
            DC(K,I) = ZERO
            DO 2130 J = 1,NCASES
               DC(K,I) = DC(K,I)+DEL(I,J)**K
 2130       CONTINUE
 2140    CONTINUE
 2150 CONTINUE
      DO 2160 I = 1,12
         B(I) = ZERO
 2160 CONTINUE
      DO 2170 I = 1,NCASES
         B(1) = B(1)+DC(1,I)
         B(2) = B(2)+DC(2,I)
         B(3) = B(3)+DC(1,I)**2
         B(5) = B(5)+DC(3,I)
         B(6) = B(6)+DC(1,I)*DC(2,I)
         B(10) = B(10)+DC(1,I)**3
 2170 CONTINUE
      DO 2190 I = 1,NCASES-1
         DO 2180 J = I+1,NCASES
            B(9) = B(9)+DC(1,I)*DC(1,J)*DEL(I,J)
 2180    CONTINUE
 2190 CONTINUE
      B(9) = B(9)*2
      DO 2240 I = 1,NCASES-2
         DO 2230 J = I+1,NCASES-1
            DO 2220 K = J+1,NCASES
               SUM = DEL(I,J)*DEL(I,K)*DEL(J,K)
               B(7) = B(7)+SUM
 2220       CONTINUE
 2230    CONTINUE
 2240 CONTINUE
      B(7) = B(7)*6
      B(4) = B(1)**2
      B(8) = B(1)*B(2)
      B(11) = B(1)*B(3)
      B(12) = B(1)**3
      A1 = B(1)
      A2 = B(2)
      A3 = B(3)-B(2)
      A4 = B(4)-A2*2-A3*4
      A5 = B(5)
      A6 = B(6)-B(5)
      A7 = B(7)
      A8 = B(8)+(B(5)-B(6)*2)*2
      A9 = B(9)+B(5)-B(6)*2-B(7)
      A10 = B(10)+B(5)*2-B(6)*3
      A11 = B(11)-(B(10)-B(7)+(B(5)+B(9))*2)*2+B(6)*10-B(8)
      A12 = B(12)-(A5+(A7+A10+(A6+A9)*3)*2)*4-(A8+A11*2)*6
      Q(1) = NCASES
      DO 2280 I = 2,6
         Q(I) = Q(I-1)*(NCASES-I+1)
 2280 CONTINUE
      D1 = A1/Q(2)
      D2 = A2/Q(2)
      D3 = A3/Q(3)
      D4 = A4/Q(4)
      D5 = A5/Q(2)
      D6 = A6/Q(3)
      D7 = A7/Q(3)
      D8 = A8/Q(4)
      D9 = A9/Q(4)
      D10 = A10/Q(4)
      D11 = A11/Q(5)
      D12 = A12/Q(6)
      M = NCASES
      VAR = (D2*(M-1)-D3*(M-2)*2+D4*(M-3))*M*(M-2)/Q(2)**2
      STDEV = DSQRT(VAR)
      T = (DBAR-D1)/STDEV
      GAM1 = (D5*(M-1)*(M-2)-D6*(M-2)*(M-2)*6+D7*(M-2)*4+
     1       (D8*3+D10*4)*(M-2)*(M-3)+(D9-D11*2)*(M-3)*(M-4)*6+
     2       D12*(M-3)*(M-5)*4)*M*(M-4)/(STDEV*Q(2))**3
      CALL PVALUE(T,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ONE,ZERO,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
