      PROGRAM POLYLSD
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PROGRAM MODIFIED 2/6/2007
C
      CHARACTER  FIN*40,FOUT*40
C
      WRITE(*,1000) '*** PROGRAM POLYLSD ***'
 1000 FORMAT(T19,A)
      WRITE(*,1100) 'PROGRAM POLYLSD COMPUTES A LEAST SQUARES ',
     +              'DEVIATION REGRESSION MODEL','AND RHO OF ',
     +              'AN EXISTING DATA SET, USING A LEAST SQUARES ',
     +              'ALGORITHM.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 1500 INDEPENDENT AND DEPENDENT OBSERVATIONS,',
     +              'N = 15 FOR AN NTH ORDER POLYNOMIAL FIT.',
     +              'RESULTS OF THIS PROGRAM ARE IN NAMED OUTPUT FILE.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T2,A,/,T10,A,/,T10,A,/,T2,A)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA:'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER ORDER OF POLYNOMIAL, 0 < N < 16:'
      READ(*,*) N
      IF(N.LT.1.OR.N.GT.15) STOP '0 < N < 16 IS NOT SATISFIED.'
      WRITE(*,*) 'ENTER POWER OF FIRST ORDER INDEPENDENT VALUE:'
      READ(*,*) POWER
      N = N+1
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      CALL LEAST(N,POWER)
      STOP 'POLYLSD RESULTS IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE LEAST(N,POWER)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(1502,17),X(16),E(1500),B(16,16),C(16),
     +           Y(1500),YH(1500),KP(16),KR(16),KC(16)
C
      ND =  16
      READ(4,*) M
      READ(4,*) (A(I,2),A(I,N+1),I = 1,M)
      CLOSE(4)
      ONE = 1.0D0
      ZERO = 0.0D0
      DO 10 I = 1,M
         A(I,1) = ONE
         A(I,2) = A(I,2)**POWER
   10 CONTINUE
      IF(N.EQ.2) GO TO 50
      DO 30 I = 1,M
         DO 20 J = 3,N
            A(I,J) =  A(I,J-1)*A(I,2)
   20    CONTINUE
   30 CONTINUE
   50 DO 100 I = 1,M
         Y(I) = A(I,N+1)
  100 CONTINUE
      DO 300 I = 1,N
         C(I) = ZERO
         DO 200 K  = 1,M
            C(I) = C(I)+Y(K)*A(K,I)
  200    CONTINUE
  300 CONTINUE
      DO 600 I = 1,N
         DO 500 J = I,N
            B(I,J) = ZERO
            DO 400 K = 1,M
               B(I,J) = B(I,J)+A(K,I)*A(K,J)
  400       CONTINUE
            B(J,I) = B(I,J)
  500    CONTINUE
  600 CONTINUE
C
      CALL INVERT(N,B,KP,KR,KC,ND)
C
      DO 800 I = 1,N
         X(I) = ZERO
         DO 700 J = 1,N
            X(I) = X(I)+C(J)*B(I,J)
  700    CONTINUE
  800 CONTINUE
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DELTA = ZERO
      DO 1000 I = 1,M
         YH(I) = ZERO
         DO 900 J = 1,N
            YH(I) = YH(I)+X(J)*A(I,J)
  900    CONTINUE
         CO = CO+Y(I)
         COO = COO+Y(I)**2
         CP = CP+YH(I)
         CPP = CPP+YH(I)**2
         COP = COP+Y(I)*YH(I)
         E(I) = Y(I)-YH(I)
         DELTA = DELTA+DABS(E(I))
 1000 CONTINUE
      DELTA = DELTA/M
      WRITE(7,1100)
 1100 FORMAT(T25,'*** OUTPUT OF POLYLSD ANALYSIS ***',2(/))
      WRITE(7,1200) N-1
 1200 FORMAT(T5,'ORDER OF POLYNOMIAL FIT = ',I2)
      WRITE(7,1400) POWER
 1400 FORMAT(T5,'POWER OF FIRST ORDER INDEPENDENT VALUE = ',G15.8,/)
      DO 1700 I = 1,N
         WRITE(7,1600) 'LSD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      WRITE(7,2000) M
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I4,/)
      CALL MRBP(M,Y,YH,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      CALL DIST(M,Y,PY)
      CALL DIST(M,E,PE)
      WRITE(7,2200) 'OBSERVED VALUE OF DELTA = ',DELTA
 2200 FORMAT(T5,A,G15.8E3)
      WRITE(7,2200) 'EXPECTED VALUE OF DELTA = ',EDEL
      WRITE(7,2200) 'VARIANCE OF DELTA = ',VAR
      WRITE(7,2200) 'SKEWNESS OF DELTA = ',GAM
      WRITE(7,2200) 'STANDARDIZED VALUE OF DELTA = ',T
      WRITE(7,2200) 'MEASURE OF AGREEMENT BETWEEN Y AND Y-HAT = ',RHO
      WRITE(7,2200) 'P-VALUE FOR THIS LAD REGRESSION FUNCTION = ',PROB
      WRITE(7,2200) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF Y = ',PY
      WRITE(7,2300) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF E = ',PE
 2300 FORMAT(T5,A,G15.8E3,/)
      R = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR =  R*R
      WRITE(7,2200) 'PEARSON CORRELATION COEFFICIENT = ',R
      WRITE(7,2300) 'SQUARED CORRELATION COEFFICIENT = ',RR
      WRITE(7,2500)
 2500 FORMAT(/,T26,'*** END OF POLYLSD ANALYSIS ***')
      RETURN
      END
C
C
      SUBROUTINE INVERT(N,W,KP,KR,KC,ND)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  KP(N),KR(N),KC(N),W(ND,N)
C
      ZERO = 0.0D0
      DO 5 I = 1,N
         KP(I) = 0
    5 CONTINUE
      DO 45 I = 1,N
         T = ZERO
         DO 20 J = 1,N
            IF(KP(J).NE.1) THEN
               DO 15 K = 1,N
                  IF(KP(K)-1) 10,15,60
   10             IF(T.LT.DABS(W(J,K))) THEN
                     IR = J
                     IC = K
                     T = DABS(W(J,K))
                  END IF
   15          CONTINUE
            END IF
   20    CONTINUE
         KP(IC) = KP(IC)+1
         IF(IR.NE.IC) THEN
            DO 25 L = 1,N
               T = W(IR,L)
               W(IR,L) = W(IC,L)
               W(IC,L) = T
   25       CONTINUE
         END IF
         KR(I) = IR
         KC(I) = IC
         T = W(IC,IC)
         W(IC,IC) = 1.0D0
         DO 30 L = 1,N
            W(IC,L) = W(IC,L)/T
   30    CONTINUE
         DO 40 M = 1,N
            IF(M.NE.IC) THEN
               T = W(M,IC)
               W(M,IC) = ZERO
               DO 35 L = 1,N
                  W(M,L) = W(M,L)-W(IC,L)*T
   35          CONTINUE
            END IF
   40    CONTINUE
   45 CONTINUE
      DO 55 I = 1,N
         J = N-I+1
         IF(KR(J).NE.KC(J)) THEN
            K = KR(J)
            L = KC(J)
            DO 50 M = 1,N
               T = W(M,K)
               W(M,K) = W(M,L)
               W(M,L) = T
   50       CONTINUE
         END IF
   55 CONTINUE
   60 RETURN
      END
C
C
      SUBROUTINE MRBP(KG,Y,YH,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  DATA(1500,2),Y(1500),YH(1500)
C
      V = 1.0D0
      DO 20 I = 1,KG
         DATA(I,1) = Y(I)
         DATA(I,2) = YH(I)
   20 CONTINUE
      CALL CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      RETURN
      END
C
C
      SUBROUTINE CALC(V,KG,DATA,DELTA,EDEL,VAR,GAM,T,RHO,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  D(3000,3000),SJ(1500,2,2),SJ2(1500,2,2),SJ3(1500,2,2),
     1   UJ(500,2,2),DATA(1500,2),SIJ(2,2),SIJ2(2,2),SIJ3(2,2),
     2   UIJ(2,2),TIJ2(2,2),TIJ3(2,2),VI(2,2)
C
      ONE=1.0D0
      ZERO=0.0D0
      K2G=KG*2
      DO 4 I=1,K2G
         DO 3 J=1,K2G
            D(I,J)=ZERO
    3    CONTINUE
    4 CONTINUE
      DO 10 I=1,KG
         DO 9 J=1,2
            DO 8 K=I,KG
               LO=1
               IF(I.EQ.K) LO=J
               DO 7 L=LO,2
                  IJ=2*(I-1)+J
                  KL=2*(K-1)+L
                  D(IJ,KL)=D(IJ,KL)+(DATA(I,J)-DATA(K,L))**2
                  D(IJ,KL)=D(IJ,KL)**(V/2)
                  D(KL,IJ)=D(IJ,KL)
    7          CONTINUE
    8       CONTINUE
    9    CONTINUE
   10 CONTINUE
      DO 30 IS=1,2
         DO 29 IR=1,2
            IF(IR.EQ.IS) GO TO 29
            SIJ(IR,IS)=ZERO
            SIJ2(IR,IS)=ZERO
            SIJ3(IR,IS)=ZERO
            DO 28 I=1,KG
               SJ(I,IR,IS)=ZERO
               SJ2(I,IR,IS)=ZERO
               SJ3(I,IR,IS)=ZERO
               DO 27 J=1,KG
                  IRR=(I-1)*2+IR
                  JSS=(J-1)*2+IS
                  SJ(I,IR,IS)=SJ(I,IR,IS)+D(IRR,JSS)
                  SJ2(I,IR,IS)=SJ2(I,IR,IS)+D(IRR,JSS)**2
                  SJ3(I,IR,IS)=SJ3(I,IR,IS)+D(IRR,JSS)**3
   27          CONTINUE
               SIJ(IR,IS)=SIJ(IR,IS)+SJ(I,IR,IS)
               SIJ2(IR,IS)=SIJ2(IR,IS)+SJ2(I,IR,IS)
               SIJ3(IR,IS)=SIJ3(IR,IS)+SJ3(I,IR,IS)
   28       CONTINUE
   29    CONTINUE
   30 CONTINUE
      TIJ2(1,2)=ZERO
      TIJ3(1,2)=ZERO
      VI(1,2)=ZERO
      UIJ(1,2)=ZERO
      DO 100 I=1,KG
         TIJ2(1,2)=TIJ2(1,2)+SJ(I,1,2)**2+
     1     SJ(I,2,1)**2
         TIJ3(1,2)=TIJ3(1,2)+SJ(I,1,2)**3+
     1     SJ(I,2,1)**3
         VI(1,2)=VI(1,2)+SJ(I,1,2)*SJ2(I,1,2)+
     1     SJ(I,2,1)*SJ2(I,2,1)
         UJ(I,1,2)=ZERO
         DO 90 J=1,KG
            IRR=2*(I-1)+1
            JSS=2*(J-1)+2
            UJ(I,1,2)=UJ(I,1,2)+
     1        D(IRR,JSS)*SJ(I,1,2)*SJ(J,2,1)
   90    CONTINUE
         UIJ(1,2)=UIJ(1,2)+UJ(I,1,2)
  100 CONTINUE
      T1=ZERO
      EDEL=ZERO
      VAR=ZERO
      IF(KG.LE.2) GO TO 150
      T1=T1+(SIJ(1,2)**3)*4-SIJ(1,2)*TIJ2(1,2)*KG*6+
     1  UIJ(1,2)*KG*KG*6+TIJ3(1,2)*KG*KG*2+
     2  SIJ(1,2)*SIJ2(1,2)*KG*KG*3-
     3  VI(1,2)*KG*KG*KG*3+SIJ3(1,2)*KG*KG*KG*KG
  150 EDEL=EDEL+SIJ(1,2)
      VAR=VAR+SIJ(1,2)*SIJ(1,2)-TIJ2(1,2)*KG+SIJ2(1,2)*KG*KG
      IF(KG.LE.2) GO TO 200
      T1=T1/(KG-2)
  200 C1=ONE/KG/KG
      EDEL=C1*EDEL
      VAR=VAR*C1*C1/(KG-1)
      GAM=C1*C1*C1*T1/(KG-1)
      GAM=GAM/DSQRT(VAR**3)
      T=(DELTA-EDEL)/DSQRT(VAR)
      RHO=ONE-(DELTA/EDEL)
      CALL PVALUE(T,GAM,PROB)
      RETURN
      END
C
C
      SUBROUTINE DIST(NCASES,DATA,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE DIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  B(12),DATA(1500),DC(3,1500),DEL(1500,1500),Q(6)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DBAR = ZERO
      DO 1400 I = 1,NCASES
         DO 1300 J = 1,NCASES
            DEL(I,J) = DABS(DATA(I)-DATA(J))
 1300    CONTINUE
 1400 CONTINUE
      DO 1600 I = 1,NCASES-1
         DBAR = DBAR+DEL(I,I+1)
 1600 CONTINUE
      DBAR = DBAR/(NCASES-1)
      DO 2150 I = 1,NCASES
         DO 2140 K = 1,3
            DC(K,I) = ZERO
            DO 2130 J = 1,NCASES
               DC(K,I) = DC(K,I)+DEL(I,J)**K
 2130       CONTINUE
 2140    CONTINUE
 2150 CONTINUE
      DO 2160 I = 1,12
         B(I) = ZERO
 2160 CONTINUE
      DO 2170 I = 1,NCASES
         B(1) = B(1)+DC(1,I)
         B(2) = B(2)+DC(2,I)
         B(3) = B(3)+DC(1,I)**2
         B(5) = B(5)+DC(3,I)
         B(6) = B(6)+DC(1,I)*DC(2,I)
         B(10) = B(10)+DC(1,I)**3
 2170 CONTINUE
      DO 2190 I = 1,NCASES-1
         DO 2180 J = I+1,NCASES
            B(9) = B(9)+DC(1,I)*DC(1,J)*DEL(I,J)
 2180    CONTINUE
 2190 CONTINUE
      B(9) = B(9)*2
      DO 2240 I = 1,NCASES-2
         DO 2230 J = I+1,NCASES-1
            DO 2220 K = J+1,NCASES
               SUM = DEL(I,J)*DEL(I,K)*DEL(J,K)
               B(7) = B(7)+SUM
 2220       CONTINUE
 2230    CONTINUE
 2240 CONTINUE
      B(7) = B(7)*6
      B(4) = B(1)**2
      B(8) = B(1)*B(2)
      B(11) = B(1)*B(3)
      B(12) = B(1)**3
      A1 = B(1)
      A2 = B(2)
      A3 = B(3)-B(2)
      A4 = B(4)-A2*2-A3*4
      A5 = B(5)
      A6 = B(6)-B(5)
      A7 = B(7)
      A8 = B(8)+(B(5)-B(6)*2)*2
      A9 = B(9)+B(5)-B(6)*2-B(7)
      A10 = B(10)+B(5)*2-B(6)*3
      A11 = B(11)-(B(10)-B(7)+(B(5)+B(9))*2)*2+B(6)*10-B(8)
      A12 = B(12)-(A5+(A7+A10+(A6+A9)*3)*2)*4-(A8+A11*2)*6
      Q(1) = NCASES
      DO 2280 I = 2,6
         Q(I) = Q(I-1)*(NCASES-I+1)
 2280 CONTINUE
      D1 = A1/Q(2)
      D2 = A2/Q(2)
      D3 = A3/Q(3)
      D4 = A4/Q(4)
      D5 = A5/Q(2)
      D6 = A6/Q(3)
      D7 = A7/Q(3)
      D8 = A8/Q(4)
      D9 = A9/Q(4)
      D10 = A10/Q(4)
      D11 = A11/Q(5)
      D12 = A12/Q(6)
      M = NCASES
      VAR = (D2*(M-1)-D3*(M-2)*2+D4*(M-3))*M*(M-2)/Q(2)**2
      STDEV = DSQRT(VAR)
      T = (DBAR-D1)/STDEV
      GAM1 = (D5*(M-1)*(M-2)-D6*(M-2)*(M-2)*6+D7*(M-2)*4+
     1       (D8*3+D10*4)*(M-2)*(M-3)+(D9-D11*2)*(M-3)*(M-4)*6+
     2       D12*(M-3)*(M-5)*4)*M*(M-4)/(STDEV*Q(2))**3
      CALL PVALUE(T,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ONE,ZERO,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
