      PROGRAM SIMWR
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  FIN*40,FOUT*40
      DIMENSION  U(17),X(10000),Y(10000)
C
      WRITE(*,1000) '*** PROGRAM SIMWR ***'
 1000 FORMAT(T19,A)
      WRITE(*,1100) 'PROGRAM SIMWR DRAWS A SAMPLE OF SIZE N FROM ',
     +              'A POPULATION OF SIZE M WITH REPLACEMENT.'
 1100 FORMAT(T2,A,/,T2,A)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER POPULATION SIZE (M) AND SAMPLE SIZE (N):'
      READ(*,*) M,N
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA:'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER RANDOM # GENERATOR SEED (ANY NON-ZERO INTEGER):'
      READ(*,*) ISEED
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      READ(4,*) (X(I),I = 1,M)
      CLOSE(4)
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 100 II = 1,17
        S = 0.0D0
        T = 0.5D0
        DO 99 JJ = 1,K
          M1 = MOD(MOD(I1*J1,179)*K1,179)
          I1 = J1
          J1 = K1
          K1 = M1
          L1 = MOD(53*L1+1,169)
          IF(MOD(L1*M1,64).GE.32) S = S+T
          T = T/2
   99   CONTINUE
        U(II) = S
  100 CONTINUE
      CALL SAMPWR(M,N,U,X,Y)
      DO 200 I = 1,N
         WRITE(7,*) Y(I)
  200 CONTINUE
      STOP 'SAMPLE DATA IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE SAMPWR(M,N,U,X,Y)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17),X(10000),Y(10000)
C
C     M: SIZE OF POPULATION
C     N: SIZE OF SAMPLE DRAWN WITH REPLACEMENT
C     X: REAL INPUT WHICH CONTAINS X(1),...,X(M) POPULATION VALUES
C     WITH REPLACEMENT SAMPLE CONTAINED IN Y(1),...,Y(N)
C
C     UNI(U) IS UNIFORM RANDOM NUMBER GENERATOR ON (0,1)
C
      DO 10 I = 1,N
         Y(I) = X(INT(1+M*UNI(U)))
   10 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
