      PROGRAM GMGF
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER FIN*40,FOUT*40
      DIMENSION U(300),C(301)
C
      WRITE(*,1) 'THE NULL HYPOTHESIS SPECIFIES THAT ',
     +           'CONTINUOUS RANDOM VARIABLE X HAS',
     +           'CUMULATIVE DISTRIBUTION FUNCTION ',
     +           'F(X).  IF Y1 < ... < YN ARE THE',
     +           'ORDER STATISTICS OF X1, ..., XN, ',
     +           'LET U(I) = F(YI) FOR I = 1, ..., N.',
     +           'THE P-VALUE HERE IS BASED ON THE ',
     +           'GREENWOOD-MORAN GOODNESS-OF-FIT',
     +           'TEST STATISTIC (T).  THE INPUT DATA ',
     +           'FILE IS THE SEQUENTIAL LIST GIVEN',
     +           'BY N,U(1), ..., U(N).  ',
     +           'ENTER NAME OF INPUT FILE.'
    1 FORMAT(//,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/)
      READ(*,2) FIN
    2 FORMAT(A)
      WRITE(*,3) 'ENTER NAME OF OUTPUT FILE.'
    3 FORMAT(/,T2,A,/)
      READ(*,2) FOUT
      ZERO = 0.0D0
      ONE = 1.0D0
      OPEN(4,FILE=FIN)
      READ(4,*) N
      READ(4,*) (U(I),I = 1,N)
      CLOSE(4)
      CALL ORDER(N,U)
      C(1) = U(1)
      DO 4 I = 2,N
         C(I) = U(I)-U(I-1)
    4 CONTINUE
      C(N+1) = ONE-U(N)
      EC = ONE/(N+1)
      T = ZERO
      DO 5 I = 1,N+1
         T = T+C(I)**2
    5 CONTINUE
      FN = ONE*N
      H = FN+ONE
      T = T*H-ONE
      CT1 = FN/(H+1)
      CT2 = 4.0D0*FN*H**2/(H+1)**2/(H+2)/(H+3)
      CT3 = 16.0D0*FN*H**3*(FN*5-2)/(H+1)**3/(H+2)/(H+3)/(H+4)/(H+5)
      ST = CT3/CT2**1.5D0
      Z = (T-CT1)/DSQRT(CT2)
      CALL PVALUE(Z,ST,P)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      WRITE(7,10) 'RESULTS OF GREENWOOD-MORAN TEST WITH ',N,
     +          ' OBSERVED VALUES'
   10 FORMAT(T5,A,I3,A)
      WRITE(7,12) T,' = OBSERVED VALUE OF STATISTIC T, TO'
      WRITE(7,12) CT1,' = EXPECTED VALUE OF STATISTIC T, E[T]'
      WRITE(7,12) CT2,' = VARIANCE OF STATISTIC T, VAR(T)'
      WRITE(7,12) Z,' = (T-E[T])/SQRT(VAR(T))'
      WRITE(7,12) ST,' = SKEWNESS OF STATISTIC T'
      WRITE(7,12) P,' = P-VALUE OF STATISTIC TO, P(T  TO)'
   12 FORMAT(T5,G16.8,A)
      END
C
C
      SUBROUTINE ORDER(N,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  N UNIVARIATE VALUES ARE ORDERED FROM SMALLEST TO LARGEST
C
      DIMENSION  X(300)
C
      ZERO = 0.0D0
C
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
C
      RETURN
      END
C
C
      SUBROUTINE PVALUE(Z,GAM,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE
C        OF Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE
C        OF Z.
C
      DOUBLE PRECISION  Z,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H2,H3,H4
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      F = R*R+10
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)-
     +    ONE/(F*F*F*360)
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      A  = R*R-1
      B  = R*R*(DLOG(R)-1)-U
      W  = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(Z.LT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = Z
      Y = Z+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(I*2-1))-R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H4 = E(G)
      PROB = G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   30 IF(Z.GT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = Z-15
      Y = Z
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(I*2-1))+R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H4 = E(G)
      PROB = ONE-G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 60
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
