      PROGRAM KSGF
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER FIN*40,FOUT*40
      DIMENSION U(300),C(301)
C
      WRITE(*,1) 'THE NULL HYPOTHESIS SPECIFIES THAT ',
     +           'CONTINUOUS RANDOM VARIABLE X HAS',
     +           'CUMULATIVE DISTRIBUTION FUNCTION ',
     +           'F(X).  IF Y1 < ... < YN ARE THE',
     +           'ORDER STATISTICS OF X1, ..., XN, ',
     +           'LET U(I) = F(YI) FOR I = 1, ..., N.',
     +           'THE P-VALUE HERE IS BASED ON THE ',
     +           'KENDALL-SHERMAN GOODNESS-OF-FIT',
     +           'TEST STATISTIC (T).  THE INPUT DATA ',
     +           'FILE IS THE SEQUENTIAL LIST GIVEN',
     +           'BY N,U(1), ..., U(N).  ',
     +           'ENTER NAME OF INPUT FILE.'
    1 FORMAT(//,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/,T2,A,A,/)
      READ(*,2) FIN
    2 FORMAT(A)
      WRITE(*,3) 'ENTER NAME OF OUTPUT FILE.'
    3 FORMAT(/,T2,A,/)
      READ(*,2) FOUT
      OPEN(4,FILE=FIN)
      READ(4,*) N
      READ(4,*) (U(I),I = 1,N)
      CLOSE(4)
      ZERO = 0.0D0
      ONE = 1.0D0
      CALL ORDER(N,U)
      C(1) = U(1)
      DO 4 I = 2,N
         C(I) = U(I)-U(I-1)
    4 CONTINUE
      C(N+1) = ONE-U(N)
      EC = ONE/(N+1)
      T = ZERO
      DO 5 I = 1,N+1
         T = T+DABS(C(I)-EC)
    5 CONTINUE
      FN = ONE*N
      H = FN+ONE
      X = T/2
      IF(X.LE.ZERO) THEN
         P = ONE
         GO TO 20
      END IF
      IF(X.GE.FN/H) THEN
         P = ZERO
         GO TO 20
      END IF
      K = IDINT(X*H)
      P = ZERO
      DO 15 I = 0,N-K-1
         DO 10 J = 0,I
            P = P+(-ONE)**(I-J)*COMB(N,J)*COMB(N+1,I+1)*COMB(N+I-J,N)
     +          *((FN-I)/H)**J*((FN-I)/H-X)**(N-J)
   10   CONTINUE
   15 CONTINUE
   20 OPEN(7,FILE=FOUT,STATUS='NEW')
      WRITE(7,25) 'RESULTS OF KENDALL-SHERMAN TEST WITH ',N,
     +          ' OBSERVED VALUES'
   25 FORMAT(T5,A,I3,A)
      WRITE(7,30) T,' = OBSERVED VALUE OF STATISTIC T, TO'
      WRITE(7,30) P,' = EXACT PVALUE OF STATISTIC TO, P(T  TO)'
   30 FORMAT(T5,G16.8,A)
      END
C
C
      SUBROUTINE ORDER(N,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  N UNIVARIATE VALUES ARE ORDERED FROM SMALLEST TO LARGEST
C
      DIMENSION  X(300)
C
      ZERO = 0.0D0
C
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
C
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION COMB(N,M)
C
      DOUBLE PRECISION  ONE,PI,R,Z,D,F,U1,U2,U3
C
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      COMB = DEXP(U1-U2-U3)
      RETURN
      END
