      PROGRAM RLADRHO
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PROGRAM MODIFIED 5/12/2001
C
      CHARACTER  FIN*40,FOUT*40,HEAD*75
      DIMENSION  U(17)
C
C   THIS PROGRAM IS CAPABLE OF MULTIPLE RUNS.  LEAVE NO BLANK LINES BETWEEN
C   DATA SETS SINCE THE FIRST LINE FOLLOWING THE LAST DATA ENTRY IS READ AS
C   A BLANK PROBLEM HEADING.
C
      WRITE(*,1000) '*** PROGRAM RLADRHO ***'
 1000 FORMAT(T20,A)
      WRITE(*,1100) 'PROGRAM RLADRHO COMPUTES A LEAST ABSOLUTE ',
     +              'DEVIATION REGRESSION AND RHO','OF AN ',
     +              'EXISTING DATA SET, USING THE ACM ALGORITHM ',
     +              'NUMBER 478.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 80 OBSERVATIONS,',
     +              'N = 20 INDEPENDENT VARIABLES.',
     +              'PROGRAM RLADRHO RESULTS ARE IN NAMED OUTPUT FILE.',
     +              'NOTE THAT THE DEPENDENT VARIABLE (Y) MUST BE ',
     +              'THE LAST VARIABLE','(THAT IS THE RIGHT-MOST ',
     +              'VARIABLE) IN THE DATA SET.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T2,A,/,T10,A,/,
     +   T10,A,/,T2,A,/,T2,A,A,/,T2,A,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA:'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,LS
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 1220 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 1210 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
 1210    CONTINUE
         U(II) = S
 1220 CONTINUE
      TOLER = 1.0D-9
      WRITE(*,1300) 'TOLERANCE = ', TOLER
 1300 FORMAT(T10,A,E10.4)
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
 1500 READ(4,1200,END=1600) HEAD
      GO TO 1800
 1600 GO TO 2000
 1800 CALL LEAST(U,ISEED,LS,TOLER,HEAD)
      GO TO 1500
 2000 CLOSE(4)
      CLOSE(7)
      END
C
C
      SUBROUTINE LEAST(U,ISEED,LS,TOLER,HEAD)
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*75
      DIMENSION  A(82,22),AS(82,22),X(20),U(17),
     +     E(80),F(80),B(80),Y(80),YH(80),YK(80)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      READ(4,*) M,N
      READ(4,*) ((A(I,J),J = 1,N+1),I = 1,M)
      DO 1000 I = 1,M
         DO 500 J = 1,N+1
            AS(I,J) = A(I,J)
  500    CONTINUE
         B(I) = A(I,N+1)
         Y(I) = B(I)
 1000 CONTINUE
      WRITE(7,1100)
 1100 FORMAT(T20,'*** OUTPUT OF RLADRHO ANALYSIS ***',/)
      WRITE(7,1200) HEAD
 1200 FORMAT(T5,A,/)
C
      CALL L1(M,N,A,B,TOLER,X,E)
C
 1500 DO 1700 I = 1,N
         WRITE(7,1600) 'LAD REGRESSION COEFFICIENT ',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      IRANK = A(M+1,N+2)
      ITER = A(M+2,N+2)
      IEXCODE = A(M+2,N+1)
      SUMRE = A(M+1,N+1)
      DELTA1 = SUMRE*(ONE+1.0D-12)/M
      WRITE(7,1800) IRANK,ITER,IEXCODE
 1800 FORMAT(/,T5,'MATRIX RANK = ',I3,/,T5,'ITERATIONS = ',I4,/,T5,
     +   'EXIT CODE =   ',I3)
      WRITE(7,1900) 'NOTE: EXIT CODE 0 INDICATES A NON-UNIQUE ',
     +   'SOLUTION.','NOTE: EXIT CODE 1 INDICATES A SUCCESSFUL ',
     +   'SOLUTION.','NOTE: EXIT CODE 2 INDICATES ROUNDING ERRORS.'
 1900 FORMAT(/,T5,A,A,/,T5,A,A,/,T5,A)
      WRITE(7,2000) M,N
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I4,/,T5,'INDEPENDENT',
     +   ' VARIABLES = ',I2,/)
      DO 2100 I = 1,M
         YH(I) = Y(I)-E(I)
         F(I) = E(I)
         YK(I) = YH(I)
 2100 CONTINUE
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DO 2200 I = 1,M
          CO = CO+Y(I)
          COO = COO+Y(I)**2
          CP = CP+YH(I)
          CPP = CPP+YH(I)**2
          COP = COP+Y(I)*YH(I)
 2200 CONTINUE
      R = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR =  R*R
      EDEL1 = ZERO
      DO 2300 I = 1,M
         DO 2250 J = 1,M
            EDEL1 = EDEL1+DABS(Y(I)-YH(J))
 2250    CONTINUE
 2300 CONTINUE
      EDEL1 = EDEL1/M/M
      RHO1 = ONE-DELTA1/EDEL1
C
      MC = M-1
      DELTA2 = ZERO
      DO 2750 I = 1,M
         YH(I) = ZERO
         DO 2550 J = 1,I-1
            DO 2500 K = 1,N+1
               A(J,K) = AS(J,K)
 2500       CONTINUE
            B(J) = AS(J,N+1)
 2550    CONTINUE
         DO 2650 J = I+1,M
            DO 2600 K = 1,N+1
               A(J-1,K) = AS(J,K)
 2600       CONTINUE
            B(J-1) = AS(J,N+1)
 2650    CONTINUE
         CALL L1(MC,N,A,B,TOLER,X,E)
         DO 2700 J = 1,N
            YH(I) = YH(I)+X(J)*AS(I,J)
 2700    CONTINUE
         DELTA2 = DELTA2+DABS(Y(I)-YH(I))
 2750 CONTINUE
      DELTA2 = DELTA2/M
      EDEL2 = ZERO
      DO 2850 I = 1,M
         DO 2800 J = 1,M
            EDEL2 = EDEL2+DABS(Y(I)-YH(J))
 2800    CONTINUE
 2850 CONTINUE
      EDEL2 = EDEL2/M/M
      RHO2 = ONE-DELTA2/EDEL2
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DO 2900 I = 1,M
          CO = CO+Y(I)
          COO = COO+Y(I)**2
          CP = CP+YH(I)
          CPP = CPP+YH(I)**2
          COP = COP+Y(I)*YH(I)
 2900 CONTINUE
      R2 = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR2 =  R2*R2
C
      CALL RMRBP(M,LS,DELTA1,PROB,U,Y,YK)
      CALL RDIST(M,LS,PY,U,Y)
      CALL RDIST(M,LS,PE,U,F)
C
      WRITE(7,3200) 'OBSERVED VALUE OF DELTA = ',DELTA1
 3200 FORMAT(T5,A,G15.8)
      WRITE(7,3200) 'EXPECTED VALUE OF DELTA = ',EDEL1
      WRITE(7,3200) 'MEASURE OF AGREEMENT BETWEEN Y AND Y-HAT = ',RHO1
      WRITE(7,3200) 'ESTIMATED SHRINKAGE MEASURE OF AGREEMENT = ',RHO2
      WRITE(7,3200) 'P-VALUE FOR THIS LAD REGRESSION FUNCTION = ',PROB
      WRITE(7,3200) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF Y = ',PY
      WRITE(7,3200) 'FIRST-ORDER AUTOREGRESSIVE P-VALUE OF E = ',PE
      WRITE(7,3200) 'PEARSON CORRELATION COEFFICIENT = ',R
      WRITE(7,3200) 'SQUARED CORRELATION COEFFICIENT = ',RR
      WRITE(7,3200) 'PEARSON SHRINKAGE CORRELATION COEFFICIENT = ',R2
      WRITE(7,3200) 'SQUARED SHRINKAGE CORRELATION COEFFICIENT = ',RR2
      WRITE(7,3300) 'RANDOM # GENERATOR SEED = ',ISEED
 3300 FORMAT(T5,A,I9)
      WRITE(7,3300) '# OF SIMULATIONS = ',LS
      WRITE(7,3500)
 3500 FORMAT('********************************************************')
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,A,B,TOLER,X,E)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(82,22),X(20),E(80),B(80),LS(80)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      M2 = M+2
      N2 = N+2
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE RMRBP(KG,MS,DELTA,PROB,U,Y,YH)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17),Y(80),YH(80),DT(80),DATA(80,2),D(160,160)
C
      ONE=1.0D0
      ZERO=0.0D0
      KB = 2
      V = ONE
      DO 2 I = 1,KG
         DATA(I,1) = Y(I)
         DATA(I,2) = YH(I)
    2 CONTINUE
      BC2=ONE*KB*(KB-1)/2
      KBG=KB*KG
      DO 4 I=1,KBG
         DO 3 J=1,KBG
            D(I,J)=ZERO
    3    CONTINUE
    4 CONTINUE
      DO 10 I=1,KG
         DO 9 J=1,KB
            DO 8 K=I,KG
               LO=1
               IF(I.EQ.K) LO=J
               DO 7 L=LO,KB
                  IJ=KB*(I-1)+J
                  KL=KB*(K-1)+L
                     D(IJ,KL)=DABS(DATA(I,J)-DATA(K,L))
                  D(KL,IJ)=D(IJ,KL)
    7          CONTINUE
    8       CONTINUE
    9    CONTINUE
   10 CONTINUE
      C0=BC2*KG
      MP = 0
      DO 200 IW = 1,MS
         DO 50 J = 2,KB
            DO 46 I = 1,KG
               DT(I) = DATA(I,J)
   46       CONTINUE
            CALL SAMPWOR(KG,KG,U,DT)
            DO 48 I = 1,KG
                  DATA(I,J) = DT(I)
   48       CONTINUE
   50    CONTINUE
         DO 54 I=1,KBG
            DO 53 J=1,KBG
               D(I,J)=ZERO
   53       CONTINUE
   54    CONTINUE
         DO 60 I=1,KG
            DO 59 J=1,KB
               DO 58 K=I,KG
                  LO=1
                  IF(I.EQ.K) LO=J
                  DO 57 L=LO,KB
                     IJ=KB*(I-1)+J
                     KL=KB*(K-1)+L
                     D(IJ,KL)=DABS(DATA(I,J)-DATA(K,L))
                     D(KL,IJ)=D(IJ,KL)
   57             CONTINUE
   58          CONTINUE
   59       CONTINUE
   60    CONTINUE
         DZ=ZERO
         DO 80 IS=2,KB
            IS1=IS-1
            DO 79 IR=1,IS1
               DO 78 I=1,KG
                  IRR=(I-1)*KB+IR
                  ISS=(I-1)*KB+IS
                  DZ=DZ+D(IRR,ISS)
   78          CONTINUE
   79       CONTINUE
   80    CONTINUE
         DZ = DZ/C0
         IF(DZ.LT.DELTA) MP = MP+1
  200 CONTINUE
      PROB = ONE*MP/MS
      RETURN
      END
C
C
      SUBROUTINE RDIST(NCASES,MS,PROB,U,DATA)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE RDIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  U(17),DATA(80),DEL(80,80)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DBAR = ZERO
      DO 1400 I = 1,NCASES
         DO 1300 J = 1,NCASES
            DEL(I,J) = DABS(DATA(I)-DATA(J))
 1300    CONTINUE
 1400 CONTINUE
      DO 1500 I = 1,NCASES-1
         DBAR = DBAR+DEL(I,I+1)
 1500 CONTINUE
      DX = DBAR*(ONE+1.0D-12)/(NCASES-1)
      MP = 0
      DO 2600 IW = 1,MS
         CALL SAMPWOR(NCASES,NCASES,U,DATA)
         DZ = ZERO
         DO 2400 I = 1,NCASES
            DO 2300 J = 1,NCASES
               DEL(I,J) = DABS(DATA(I)-DATA(J))
 2300       CONTINUE
 2400    CONTINUE
         DO 2500 I = 1,NCASES-1
            DZ = DZ+DEL(I,I+1)
 2500    CONTINUE
         DZ = DZ/(NCASES-1)
         IF(DZ.LT.DX) MP = MP+1
 2600 CONTINUE
      PROB = ONE*MP/MS
      RETURN
      END
C
C
      SUBROUTINE SAMPWOR(M,N,U,DATA)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17),DATA(80)
C
C     M: SIZE OF POPULATION
C     N: SIZE OF SAMPLE DRAWN WITHOUT REPLACEMENT (1 </= N </= M)
C     DATA: REAL INPUT WHICH CONTAINS DATA(1),...,DATA(M) POPULATION VALUES
C     WITHOUT REPLACEMENT SAMPLE CONTAINED IN DATA(1),...,DATA(N)
C
C     UNI(U) IS UNIFORM RANDOM NUMBER GENERATOR ON (0,1)
C
      DO 10 I = 1,N
         J = INT(I+(M-I+1)*UNI(U))
         BIN = DATA(J)
         DATA(J) = DATA(I)
         DATA(I) = BIN
   10 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
