      PROGRAM RMEDQ1
      IMPLICIT REAL*8(A-H,O-Z)
C
C  SELECTIONS OF QUANTILES ARE OBTAINED FOR A UNIVARIATE SET
C  OF DATA AND ALSO DISTANCES OF THE SAME SET FROM THE MEDIAN
C  NOTE:  THE UNIVARIATE DATA SET SIZE MUST BE AT LEAST 2
C
      DIMENSION  X(700),U(700),V(700)
      CHARACTER  FIN*40,FOUT*40,DIS1*40
C
      ZERO = 0.0D0
      WRITE(*,*) 'ENTER N (TOTAL NUMBER OF VALUES)'
      READ(*,*) N
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,'(A)') FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,'(A)') FOUT
      WRITE(*,*) 'ENTER FILE NAME FOR DISTANCES FROM MEDIAN'
      READ(*,'(A)') DIS1
      WRITE(*,*) 'ENTER P FOR P-TH SAMPLE QUANTILE (0 < P < 1)'
      READ(*,*) P1
      WRITE(*,*) 'ENTER P FOR P-TH DISTANCE QUANTILE FROM MEDIAN'
      READ(*,*) P2
      OPEN(1,FILE=FIN)
      READ(1,*) (X(I),I=1,N)
      CLOSE(1)
      DO 5 I = 1,N
         V(I) = X(I)
    5 CONTINUE
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
      OPEN(2,FILE = FOUT,STATUS = 'NEW')
      WRITE(2,72) '1-DIMENSIONAL SAMPLE QUANTILE VALUES'
   72 FORMAT(T10,A,//)
      WRITE(2,74) 'NUMBER OF OBSERVATIONS = ',N
   74 FORMAT(T5,A,I3,/)
      WRITE(2,75) 'SELECTED P FOR P-TH SAMPLE QUANTILE =', P1
   75 FORMAT(T5,A,G16.10,/)
      K = MAX(1,IDNINT(P1*N+0.5D0))
      WRITE(2,76) 'P-TH SAMPLE QUANTILE =',X(K)
   76 FORMAT(T5,A,G16.10)
      WRITE(2,76) '0.0-TH SAMPLE QUANTILE (MINIMUM VALUE) =',X(1)
      K = MAX(1,IDNINT(0.05D0*N+0.5D0))
      WRITE(2,76) 'O.O5-TH SAMPLE QUANTILE =',X(K)
      K = MAX(1,IDNINT(0.1D0*N+0.5D0))
      WRITE(2,76) '0.1-TH SAMPLE QUANTILE =',X(K)
      K = MAX(1,IDNINT(0.25D0*N+0.5D0))
      WRITE(2,76) '0.25-TH SAMPLE QUANTILE =',X(K)
      K = IDINT(0.5D0*N+0.51D0)
      Y = X(K)
      L = N/2
      IF(K.EQ.L) Y = (X(K)+X(K+1))/2
      WRITE(2,78) '0.5-TH SAMPLE QUANTILE (MEDIAN VALUE) =',Y
   78 FORMAT(/,T5,A,G16.10,/)
      K = MIN(N,IDNINT(0.75D0*N+0.5D0))
      WRITE(2,76) '0.75-TH SAMPLE QUANTILE =',X(K)
      K = MIN(N,IDNINT(0.9D0*N+0.5D0))
      WRITE(2,76) '0.9-TH SAMPLE QUANTILE =',X(K)
      K = MIN(N,IDNINT(0.95D0*N+0.5D0))
      WRITE(2,76) '0.95-TH SAMPLE QUANTILE =',X(K)
      WRITE(2,80) '1.0-TH SAMPLE QUANTILE (MAXIMUM VALUE) =',X(N)
   80 FORMAT(T5,A,G16.10,////)
      D = ZERO
      DO 85 I = 1,N
        U(I) = DABS(V(I)-Y)
        D = D+U(I)
   85 CONTINUE
      D = D/N
C
C           U(I) IS THE DISTANCE FROM THE ITH POINT TO THE MEDIAN
C
      OPEN(2,FILE = FOUT,STATUS = 'NEW')
      WRITE(2,72) '1-DIMENSIONAL DISTANCE FROM MEDIAN QUANTILES'
      WRITE(2,75) 'AVERAGE DISTANCE TO MEDIAN = ',D
C
      OPEN(5,FILE=DIS1,STATUS='NEW')
      DO 88 I = 1,N
        WRITE(5,*) U(I)
   88 CONTINUE
      CLOSE(5)
C
      J = N
      K = J/2+1
   91 K = K-1
      W = U(K)
      GO TO 93
   92 W = U(J)
      U(J) = U(1)
      J = J-1
   93 II = K
   94 L = 2*II
      IF(L-J)  95,96,97
   95 IF(U(L+1).GE.U(L)) L = L+1
   96 IF(W.GE.U(L)) GO TO 97
      U(II) = U(L)
      II = L
      GO TO 94
   97 U(II) = W
      IF(K.GT.1) GO TO 91
      IF(J.GE.2) GO TO 92
      WRITE(2,75) 'SELECTED P FOR P-TH DIST. QUANT. FROM MEDIAN =', P2
      K = MAX(1,IDNINT(P2*N+0.5D0))
      WRITE(2,76) 'P-TH DISTANCE QUANTILE =',U(K)
      WRITE(2,76) '0.0-TH DISTANCE QUANTILE (MINIMUM VALUE) =',U(1)
      K = MAX(1,IDNINT(0.05D0*N+0.5D0))
      WRITE(2,76) 'O.O5-TH DISTANCE QUANTILE =',U(K)
      K = MAX(1,IDNINT(0.1D0*N+0.5D0))
      WRITE(2,76) '0.1-TH DISTANCE QUANTILE =',U(K)
      K = MAX(1,IDNINT(0.25D0*N+0.5D0))
      WRITE(2,76) '0.25-TH DISTANCE QUANTILE =',U(K)
      K = IDINT(0.5D0*N+0.51D0)
      G = U(K)
      L = N/2
      IF(K.EQ.L) G = (U(K)+U(K+1))/2
      WRITE(2,76) '0.5-TH DISTANCE QUANTILE (MEDIAN VALUE) =',G
      K = MIN(N,IDNINT(0.75D0*N+0.5D0))
      WRITE(2,76) '0.75-TH DISTANCE QUANTILE =',U(K)
      K = MIN(N,IDNINT(0.9D0*N+0.5D0))
      WRITE(2,76) '0.9-TH DISTANCE QUANTILE =',U(K)
      K = MIN(N,IDNINT(0.95D0*N+0.5D0))
      WRITE(2,76) '0.95-TH DISTANCE QUANTILE =',U(K)
      WRITE(2,76) '1.0-TH DISTANCE QUANTILE (MAXIMUM VALUE) =',U(N)
      CLOSE(2)
      END
