      PROGRAM RSE
      IMPLICIT REAL*8(A-H,O-Z)
C
C  THIS IS A TWO-SAMPLE RIDIT ANALYSIS PROGRAM YIELDING APPROXIMATE
C  ASYMPTOTIC STANDARD ERRORS OF THE RIDIT STATISTIC.  FREQUENCIES
C  FOR THE K DISCRETE CELLS ARE ENTERED INTERACTIVELY (K < 51).  IF
C  THE TREATMENT-CONTROL VERSION OF RIDIT IS CONSIDERED, THE LETTERS
C  A AND B CORRESPOND TO CONTROL AND TREATMENT' RESPECTIVELY.
C
C         PROGRAM MODIFIED 12/10/2004
C
      CHARACTER  FOUT*40
      DIMENSION  U(17),LA(50),LB(50),RA(50),RB(50)
C
C  IF K > 50, REPLACE 50 WITH K IN LA(K), LB(K), RA(K) AND RB(K) ABOVE.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,1) 'RIDIT ANALYSES: APPROXIMATE STANDARD ERRORS'
    1 FORMAT(T2,A)
      WRITE(*,1) 'ENTER K, THE NUMBER OF CELLS:'
      READ(*,*) K
      WRITE(*,1) 'ENTER SAMPLE 1 FREQUENCIES LA1,...,LAK:'
      READ(*,*) (LA(I),I=1,K)
      WRITE(*,1) 'ENTER SAMPLE 2 FREQUENCIES LB1,...,LBK:'
      READ(*,*) (LB(I),I=1,K)
      WRITE(*,1) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,3) FOUT
    3 FORMAT(A)
      LAT = 0
      LBT = 0
      DO 4 I = 1,K
        LAT = LAT+LA(I)
        LBT = LBT+LB(I)
        RA(I) = ZERO
        RB(I) = ZERO
    4 CONTINUE
      RA(1) = ONE*LA(1)/(2*LAT)
      DO 7 I = 2,K
        RA(I) = ONE*LA(I)/(2*LAT)
        DO 6 J = 1,I-1
          RA(I) = RA(I)+ONE*LA(J)/LAT
    6   CONTINUE
    7 CONTINUE
      RB(1) = ONE*LB(1)/(2*LBT)
      DO 9 I = 2,K
        RB(I) = ONE*LB(I)/(2*LBT)
        DO 8 J = 1,I-1
          RB(I) = RB(I)+ONE*LB(J)/LBT
    8   CONTINUE
    9 CONTINUE
      CA = ONE*LAT
      CB = ONE*LBT
      A = CA+CB
      XA = ZERO
      XB = ZERO
      B = ZERO
      C = ZER0
      D = ZERO
      DO 10 I = 1,K
        XA = XA+RB(I)*LA(I)/LAT
        XB = XB+RA(I)*LB(I)/LBT
        B = B+ONE*(LA(I)-LB(I))**3
        C = C+RA(I)*RA(I)*LB(I)
        D = D+RA(I)*RA(I)*LB(I)*(CB-LB(I))
   10 CONTINUE
C      T = XB  AND  W = XB-XA
      X1 = DSQRT(ONE/(CB*12))
      X2 = DSQRT(A/(CA*CB*12))
      X3 = DSQRT((A**3-B)/(CA*CB*A*(A-1)*12))
      X4 = DSQRT((A+1)/(CA*CB*12))
      X5 = DSQRT((C-CB*XB*XB)/CB**2)
      X6 = DSQRT(D/CB**3)
C
      OPEN(5,FILE=FOUT,STATUS='NEW')
      WRITE(5,310) 'APPROXIMATE STANDARD ERRORS FOR RIDIT ANALYSES ',
     +             'WITH ',K,' CELLS'
      WRITE(5,330) 'NUMBER OF CASES IN SAMPLE 1 = ',LAT
      WRITE(5,330) 'NUMBER OF CASES IN SAMPLE 2 = ',LBT
      WRITE(5,320) X1, ' = BROSS (1958) STANDARD ERROR'
      WRITE(5,320) X2, ' = SELVIN (1977) STANDARD ERROR'
      WRITE(5,320) X3, ' = FLEISS (1981) STANDARD ERROR'
      WRITE(5,320) X4, ' = JANSEN (1984) STANDARD ERROR'
      WRITE(5,320) X5, ' = BEDER & HEIM (1990) STANDARD ERROR'
      WRITE(5,320) X6, ' = SERMEUS & DELESIE (1996) STANDARD ERROR'
  310 FORMAT(/,T2,A,A,I3,A,/)
  320 FORMAT(T5,D16.9,A)
  330 FORMAT(T5,A,I9)
      END
