      PROGRAM F2X2X2
      IMPLICIT REAL*8(A-H,O-Z)
C
C     PROGRAM F2X2X2 IS A DRIVER PROGRAM, CALLING A SPECIFIC SUBROUTINE
C     TO COMPUTE FISHER'S EXACT, EXACT CHI-SQUARE, EXACT ZELTERMAN,
C     AND EXACT LOG-LIKELIHOOD RATIO TEST P-VALUES FOR 2 X 2 X 2
C     CROSS-CLASSIFICATION TABLES.
C
      CHARACTER  FOUT*40
      DIMENSION  N(2,2,2)
C
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,2) '2X2X2 TABLE FISHER''S & CHI-SQUARED EXACT TESTS'
    2 FORMAT(/,T2,A,/)
      WRITE(*,3) 'ENTER N111 AND N211 OF THE 2X2X2 TABLE'
    3 FORMAT(T2,A)
      READ(*,*)  N(1,1,1),N(2,1,1)
      WRITE(*,3) 'ENTER N121 AND N221 OF THE 2X2X2 TABLE'
      READ(*,*)  N(1,2,1),N(2,2,1)
      WRITE(*,3) 'ENTER N112 AND N212 OF THE 2X2X2 TABLE'
      READ(*,*)  N(1,1,2),N(2,1,2)
      WRITE(*,3) 'ENTER N122 AND N222 OF THE 2X2X2 TABLE'
      READ(*,*)  N(1,2,2),N(2,2,2)
      CALL FE2X2X2(N,PT,CST,OCS,CZT,OCZ,ZLT,PFE,PCS,PZS,PLS,CTAB,
     +  CFE,CCS,CZS,CLS,CHECK)
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,5)
    5 FORMAT(T15,'2X2X2 TABLE FISHER''S & CHI-SQUARED EXACT TESTS',/)
      WRITE(6,6) 'N111 & N211 OF 2X2X2 TABLE: ',N(1,1,1),N(2,1,1)
    6 FORMAT(T5,A,2I6)
      WRITE(6,6) 'N121 & N221 OF 2X2X2 TABLE: ',N(1,2,1),N(2,2,1)
      WRITE(6,6) 'N112 & N212 OF 2X2X2 TABLE: ',N(1,1,2),N(2,1,2)
      WRITE(6,6) 'N122 & N222 OF 2X2X2 TABLE: ',N(1,2,2),N(2,2,2)
      WRITE(6,7) '# OF TABLES CONSISTENT WITH MARGINAL TOTALS = ',CTAB
    7 FORMAT(/,T5,A,D20.13)
      WRITE(6,8) '# OF TABLES YIELDING FISHER''S EXACT P-VALUE = ',CFE
    8 FORMAT(T5,A,D20.13)
      WRITE(6,8) 'P(OBSERVED TABLE) = ',PT
      WRITE(6,8) 'FISHER''S EXACT 2X2X2 TABLE P-VALUE = ',PFE
      WRITE(6,8) '# OF TABLES YIELDING EXACT CHI-SQUARED P-VALUE = ',CCS
      IF(CST.LT.0.0D0) CST = 0.0D0
      WRITE(6,8) 'OBSERVED CHI-SQUARED STATISTIC = ',CST
      WRITE(6,8) 'STANDARDIZED CHI-SQUARED STATISTIC = ',OCS
      WRITE(6,8) 'EXACT CHI-SQUARED 2X2X2 TABLE P-VALUE = ',PCS
      WRITE(6,8) '# OF TABLES YIELDING EXACT ZELTERMAN P-VALUE = ',CZS
      IF(CZT.LT.0.0D0) CZT = 0.0D0
      WRITE(6,8) 'OBSERVED ZELTERMAN STATISTIC = ',CZT
      WRITE(6,8) 'EXACT ZELTERMAN 2X2X2 TABLE P-VALUE = ',PZS
      WRITE(6,8) '# OF TABLES YIELDING EXACT LOG LR P-VALUE = ',CLS
      IF(ZLT.LT.0.0D0) ZLT = 0.0D0
      WRITE(6,8) 'OBSERVED LOG-LR STATISTIC = ',ZLT
      WRITE(6,8) 'EXACT LOG LR 2X2X2 TABLE P-VALUE = ',PLS
      WRITE(6,8) 'SUM OF ALL CONFIGURATION PROBABILITIES = ',CHECK
      IDF = 4
      CALL CHISQ(OCS,IDF,PACS)
      WRITE(6,7) 'ASYMPTOTIC CHI-SQUARED 2X2X2 TABLE P-VALUE = ',PACS
      CALL CHISQ(OCZ,IDF,PACZ)
      WRITE(6,8) 'ASYMPTOTIC ZELTERMAN 2X2X2 TABLE P-VALUE = ',PACZ
      CALL CHISQ(ZLT,IDF,PALS)
      WRITE(6,8) 'ASYMPTOTIC L-R TEST 2X2X2 TABLE P-VALUE = ',PALS
      END
C
C
      SUBROUTINE FE2X2X2(L,PT,CST,OCS,CZT,OCZ,ZLT,PFE,PCS,PZS,PLS,CTAB,
     +   CFE,CCS,CZS,CLS,CHECK)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  A FISHER'S EXACT TEST FOR TESTING THE MUTUAL INDEPENDENCE OF THREE
C  CLASSIFICATIONS IN A 2 X 2 X 2 CONTINGENCY TABLE.
C
C     DESCRIPTION OF VARIABLES IN CALL LIST:
C        L     -- INPUT,  ARRAY CONTAINING THE CELL FREQUENCIES
C        PFE   -- OUTPUT, FISHER'S EXACT PROBABILITY VALUE (P-VALUE)
C        PCS   -- OUTPUT, EXACT CHI-SQUARED PROBABILITY VALUE (P-VALUE)
C        PZS   -- OUTPUT, EXACT ZELTERMAN PROBABILITY VALUE (P-VALUE)
C        PLS   -- OUTPUT, EXACT L-R TEST PROBABILITY VALUE (P-VALUE)
C        PT    -- OUTPUT, POINT PROBABILITY OF OBSERVED TABLE
C        CTAB  -- OUTPUT, # OF TABLES CONSISTENT WITH MARGINAL TOTALS
C        CFE   -- OUTPUT, # OF TABLES COMPRISING FISHER'S EXACT P-VALUE
C        CCS   -- OUTPUT, # OF TABLES COMPRISING EXACT CHI-SQUARED P-VALUE
C        CZS   -- OUTPUT, # OF TABLES COMPRISING EXACT ZELTERMAN P-VALUE
C        CLS   -- OUTPUT, # OF TABLES COMPRISING EXACT L-R TEST P-VALUE
C     USAGE:
C        SUBROUTINE FE2X2X2 COMPUTES THE FISHER EXACT PROBABILITY
C        TEST FOR 2 BY 2 BY 2 CROSS-CLASSIFICATION TABLES
C
      DIMENSION K(2,2,2),L(2,2,2),KS(3,2),LS(3,2)
C
C  OBTAIN THE THREE ONE-WAY MARGINAL TOTALS AND GRAND TOTAL.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      IA = L(1,1,1)+L(1,1,2)+L(1,2,1)+L(1,2,2)
      IB = L(1,1,1)+L(1,1,2)+L(2,1,1)+L(2,1,2)
      IC = L(1,1,1)+L(1,2,1)+L(2,1,1)+L(2,2,1)
      IT = IA+L(2,1,1)+L(2,1,2)+L(2,2,1)+L(2,2,2)
C  FIND THE COMMON PART OF EACH TABLES EXACT PROBABILITY VALUE.
      PSTART = FAC(IA)+FAC(IB)+FAC(IC)+FAC(IT-IA)+
     &         FAC(IT-IB)+FAC(IT-IC)-FAC(IT)*2
C  DETERMINE THE PROBABILITY OF THE OBSERVED TABLE.
      THISP = (PSTART-CELLFAC(L))*(1.0D0-1.0D-12)
      LS(1,1) = IA
      LS(1,2) = IT-IA
      LS(2,1) = IB
      LS(2,2) = IT-IB
      LS(3,1) = IC
      LS(3,2) = IT-IC
      CZ = RZ(IT*IT)/IT
      DO 5 I = 1,2
         CZ = CZ-RZ(LS(1,I))
    5 CONTINUE
      DO 6 I = 1,2
         CZ = CZ-RZ(LS(2,I))
    6 CONTINUE
      DO 7 I = 1,2
         CZ = CZ-RZ(LS(3,I))
    7 CONTINUE
      CST = CS(L,LS)
      OCS = CST*IT*IT-IT
      CST = CST*(ONE-1.0D-12)
      IF(CST.LT.1.0D-11) CST = -1.0D-11
      CZT = DS(L,LS)
      OCZ = CZT*IT*IT+8.0D0-IT
      CZT = CZT*(ONE-1.0D-12)
      IF(CZT.LT.1.0D-11) CZT = -1.0D-11
      ZLT = ZL(L,CZ)*(1.0D0-1.0D-12)
      IF(ZLT.LT.1.0D-11) ZLT = -1.0D-11
C
      IA = MIN0(IA,IT-IA)
      IB = MIN0(IB,IT-IB)
      IC = MIN0(IC,IT-IC)
      IF(IC.LE.IB.AND.IB.LE.IA) THEN
         MA = IC
         MB = IB
         MC = IA
      ELSE IF(IC.LE.IA.AND.IA.LE.IB) THEN
         MA = IC
         MB = IA
         MC = IB
      ELSE IF(IB.LE.IC.AND.IC.LE.IA) THEN
         MA = IB
         MB = IC
         MC = IA
      ELSE IF(IB.LE.IA.AND.IA.LE.IC) THEN
         MA = IB
         MB = IA
         MC = IC
      ELSE IF(IA.LE.IC.AND.IC.LE.IB) THEN
         MA = IA
         MB = IC
         MC = IB
      ELSE
         MA = IA
         MB = IB
         MC = IC
      END IF
      KS(1,1) = MA
      KS(1,2) = IT-MA
      KS(2,1) = MB
      KS(2,2) = IT-MB
      KS(3,1) = MC
      KS(3,2) = IT-MC
C  INITIALIZATION OF VARIOUS VALUES FOR SUBSEQUENT SUMMATIONS.
      CTAB = ZERO
      CHECK = ZERO
      CFE = ZERO
      PFE = ZERO
      CCS = ZERO
      PCS = ZERO
      CZS = ZERO
      PZS = ZERO
      CLS = ZERO
      PLS = ZERO
C  FOUR MAJOR LOOPS DETERMINE THE VALID TABLES FROM ALL VALUES OF FOUR SPECIFIED
C  CELLS (THE FOUR REMAINING CELLS ARE OBTAINED FROM THE FOUR SPECIFIED CELLS).
      MABC = MA+MB+MC-IT
      MW = MA
      DO 40 IW = 0,MW
         K(1,1,1) = IW
         MX = MA-IW
         DO 30 IX = 0,MX
            K(1,1,2) = IX
            MY = MA-IW-IX
            DO 20 IY = 0,MY
               K(1,2,1) = IY
               K(1,2,2) = MA-IW-IX-IY
               LZ = MAX0(0,MABC-IW*2-IX-IY)
               MZ = MIN0(MB-IW-IX,MC-IW-IY)
               DO 10 IZ = LZ,MZ
                  CTAB = CTAB+1
                  K(2,1,1) = IZ
                  K(2,1,2) = MB-IW-IX-IZ
                  K(2,2,1) = MC-IW-IY-IZ
                  K(2,2,2) = IT-MC-IX-K(1,2,2)-K(2,1,2)
                  CP = PSTART-CELLFAC(K)
                  EXCP = DEXP(CP)
                  CHECK = CHECK+EXCP
C  OBTAIN EXACT P-VALUES OF OBSERVED TABLE.
                  IF(CP.LT.THISP) THEN
                     CFE = CFE+ONE
                     PFE = PFE+EXCP
                  END IF
                  Z = CS(K,KS)
                  IF(Z.GT.CST) THEN
                     CCS = CCS+ONE
                     PCS = PCS+EXCP
                  END IF
                  Y = DS(K,KS)
                  IF(Y.GT.CZT) THEN
                     CZS = CZS+ONE
                     PZS = PZS+EXCP
                  END IF
                  W = ZL(K,CZ)
                  IF(W.GT.ZLT) THEN
                     CLS = CLS+ONE
                     PLS = PLS+EXCP
                  ENDIF
   10          CONTINUE
   20       CONTINUE
   30    CONTINUE
   40 CONTINUE
      PT = DEXP(THISP)
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C  FIND I(LOG(I))
      DOUBLE PRECISION  X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(2500)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION CELLFAC(N)
C  OBTAIN SUM OF LOG FACTORIALS FOR EIGHT CELLS.
      DOUBLE PRECISION  FAC
      INTEGER  I,J,K,N(2,2,2)
      CELLFAC = 0.0D0
      DO 30 I = 1,2
         DO 20 J = 1,2
            DO 10 K = 1,2
               CELLFAC = CELLFAC+FAC(N(I,J,K))
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION CS(M,N)
C  OBTAIN CHI-SQUARED STATISTIC
      DOUBLE PRECISION  ZERO,ONE
      INTEGER  M(2,2,2),N(3,2)
      ZERO = 0.0D0
      ONE = 1.0D0
      CS = ZERO
      DO 30 I = 1,2
         DO 20 J = 1,2
            DO 10 K = 1,2
               CS = CS+(ONE*M(I,J,K))**2/(N(1,I)*N(2,J)*N(3,K))
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION DS(M,N)
C  OBTAIN CHI-SQUARED STATISTIC
      DOUBLE PRECISION  ZERO,ONE
      INTEGER  M(2,2,2),N(3,2)
      ZERO = 0.0D0
      ONE = 1.0D0
      DS = ZERO
      DO 30 I = 1,2
         DO 20 J = 1,2
            DO 10 K = 1,2
               DS = DS+ONE*M(I,J,K)*(M(I,J,K)-1)/N(1,I)/N(2,J)/N(3,K)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION ZL(N,CZ)
C  OBTAIN LOG LIKELIHOOD RATIO STATISTIC
      DOUBLE PRECISION  ZERO,CZ,RZ
      INTEGER  N(2,2,2),I,J,K
      ZERO = 0.0D0
      ZL = ZERO
      DO 30 I = 1,2
         DO 20 J = 1,2
            DO 10 K = 1,2
               ZL = ZL+RZ(N(I,J,K))
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      ZL = (ZL+CZ)*2
      RETURN
      END
C
C
      SUBROUTINE CHISQ(T,N,P)
      DOUBLE PRECISION T,ZERO,ONE,V,P,PI,A,B,E1,E2,E3,E4,E5,H,W
      ZERO = 0.0D0
      ONE = 1.0D0
      IF(T.LT.ZERO) THEN
         P = ONE
         GO TO 60
      END IF
      V = ONE*N
      IF(V/2-N/2.GT.0.1D0) GO TO 30
      P = DEXP(-T/2)
      IF(N.LT.3) GO TO 60
      K = (N-2)/2
      B = ONE
      DO 20 J = 1,K
         L = J
         A = ONE
         DO 10 I = 1,L
            A = A*T/(2*I)
   10    CONTINUE
         B = B+A
   20 CONTINUE
      P = P*B
      GO TO 60
   30 PI = DATAN(ONE)*4
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*DSQRT(T)+1)
      P = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*DEXP(-T/2)/DSQRT(PI/2)
      IF(N.LT.2) GO TO 60
      K = (N-1)/2
      B = ZERO
      DO 50 J = 1,K
         L = J
         A = ONE
         DO 40 I = 1,L
            A = A*T/(2*I-1)
   40    CONTINUE
         B = B+A
   50 CONTINUE
      P = P+B*DEXP(-T/2)/DSQRT(PI*T/2)
   60 RETURN
      END
